{-# LANGUAGE TemplateHaskell     #-}

module Phoityne.VSCode.TH.SourceBreakpointJSON where

import Data.Aeson.TH

import Phoityne.VSCode.Utility

-- |
--   Properties of a breakpoint passed to the setBreakpoints request.
--
data SourceBreakpoint =
  SourceBreakpoint {
    lineSourceBreakpoint      :: Int           -- The source line of the breakpoint. 
  , columnSourceBreakpoint    :: Maybe Int     -- An optional source column of the breakpoint.
  , conditionSourceBreakpoint :: Maybe String  --  An optional expression for conditional breakpoints.
  } deriving (Show, Read, Eq)

$(deriveJSON defaultOptions { fieldLabelModifier = rdrop (length "SourceBreakpoint") } ''SourceBreakpoint)


